Index: /trunk/DataCheck/Transfer/CheckTransfer.sh
===================================================================
--- /trunk/DataCheck/Transfer/CheckTransfer.sh	(revision 18866)
+++ /trunk/DataCheck/Transfer/CheckTransfer.sh	(revision 18867)
@@ -18,11 +18,20 @@
 date > $logfile2 2>&1
 
-diskusage=( `ssh fact@161.72.93.131 "df -P /daq" | grep daq ` )
-# check if more than X GB are left on /daq
+diskusage=( `ssh fact@161.72.93.138 "df -P /data1" | grep data1 ` )
+# check if more than X GB are left on newdata /data1
 if [ ${diskusage[3]} -lt 700000 ] 
 then
-   printprocesslog "DISK less than 700 GB left on /daq ("${diskusage[3]}")"
-   echo "WARN less than 700 GB left on /daq ("${diskusage[3]}")"
-   echo "WARN less than 700 GB left on /daq ("${diskusage[3]}")" >> $logfile2 2>&1
+   printprocesslog "DISK less than 700 GB left on newdata on /data1 ("${diskusage[3]}")"
+   echo "WARN less than 700 GB left on newdata on /data1 ("${diskusage[3]}")"
+   echo "WARN less than 700 GB left on newdata on /data1 ("${diskusage[3]}")" >> $logfile2 2>&1
+   sendemail="yes"
+fi
+diskusage=( `ssh fact@161.72.93.138 "df -P /data2" | grep data2 ` )
+# check if more than X GB are left on newdata /data2
+if [ ${diskusage[3]} -lt 700000 ] 
+then
+   printprocesslog "DISK less than 700 GB left on newdata on /data2 ("${diskusage[3]}")"
+   echo "WARN less than 700 GB left on newdata on /data2 ("${diskusage[3]}")"
+   echo "WARN less than 700 GB left on newdata on /data2 ("${diskusage[3]}")" >> $logfile2 2>&1
    sendemail="yes"
 fi
@@ -42,5 +51,5 @@
 
 # check first the disk in LP and on dl00
-ssh fact@161.72.93.131 "df -h /*da*"
+ssh fact@161.72.93.138 "df -h /*da*"
 df -h /scratch
 echo ""
@@ -83,5 +92,5 @@
 
 # get nights from directory in LP
-dates=( `ssh fact@161.72.93.131 "find /loc_data/zipraw -mindepth 3 -type d | sort | sed -e 's/\/loc_data\/zipraw\///g' "` )
+dates=( `ssh fact@161.72.93.138 "find /data2/zipraw -mindepth 3 -type d | sort | sed -e 's/\/data2\/zipraw\///g' "` )
 
 numdaysok=0
@@ -146,13 +155,10 @@
    # la palma
    lprawpath="/newdaq/raw/"$date
-   lprawpath2="/daq/raw/"$date
-#   lprawpath2="/newdaq/raw/"$date #if daq is down
-   lpziprawpath="/loc_data/zipraw/"$date
-   qlapath="/daq/analysis/callisto/"$date
-#   qlapath="/newdaq/analysis/callisto/"$date #if daq is down
+   lprawpath2="/data1/raw/"$date
+   lpziprawpath="/data2/zipraw/"$date
+   qlapath="/data1/analysis/callisto/"$date
    # isdc
    localrawpath="/scratch/from_lapalma/raw/"$date
    localrawpath3="/fact/raw/"$date
-#   localfailpath="/archive/fact/fails/raw/"$date
    localfailpath="/gpfs/fact/fact-archive/fails/raw/"$date
    # wuerzburg
@@ -163,7 +169,7 @@
    # get disk usage and number of files for directory
    #   on newdaq files with more than 3 digits as run number are excluded
-   newdaq=( `ssh fact@161.72.93.131 "if [ -d $lprawpath ]; then ls $lprawpath/${date2}_[0-9][0-9][0-9][.]* | wc -l; du -s -b --apparent-size $lprawpath; else echo '-1 -1 -1'; fi"` )
-   daq=( `ssh fact@161.72.93.131 "if [ -d $lprawpath2 ]; then ls $lprawpath2/${date2}_[0-9][0-9][0-9][.]* | wc -l; du -s -b --apparent-size $lprawpath2; else echo '-1 -1 -1'; fi"` )
-   if [ ${newdaq[0]} -eq -1 ] && [ ${daq[0]} -eq -1 ] 
+   newdaq=( `ssh fact@161.72.93.138 "if [ -d $lprawpath ]; then ls $lprawpath/${date2}_[0-9][0-9][0-9][.]* | wc -l; du -s -b --apparent-size $lprawpath; else echo '-1 -1 -1'; fi"` )
+   daq=( `ssh fact@161.72.93.138 "if [ -d $lprawpath2 ]; then ls $lprawpath2/${date2}_[0-9][0-9][0-9][.]* | wc -l; du -s -b --apparent-size $lprawpath2; else echo '-1 -1 -1'; fi"` )
+   if [ ${newdaq[0]} -eq -1 ] 
    then
       printprocesslog "INFO no data available on newdaq for "$date
@@ -171,5 +177,11 @@
       continue
    fi
-   zip=( `ssh fact@161.72.93.131 "if [ -d $lpziprawpath ]; then ls $lpziprawpath/${date2}_[0-9][0-9][0-9][.]* 2>/dev/null | wc -l; du -s -b --apparent-size $lpziprawpath; else echo '-1 -1 -1'; fi"` )
+   if [ ${daq[0]} -eq -1 ] 
+   then
+      printprocesslog "INFO no data available on newdata for "$date
+      echo "INFO no data available on newdata for "$date >> $logfile 2>&1
+      continue
+   fi
+   zip=( `ssh fact@161.72.93.138 "if [ -d $lpziprawpath ]; then ls $lpziprawpath/${date2}_[0-9][0-9][0-9][.]* 2>/dev/null | wc -l; du -s -b --apparent-size $lpziprawpath; else echo '-1 -1 -1'; fi"` )
    dl00=( `if [ -d $localrawpath ]; then ls $localrawpath/${date2}_[0-9][0-9][0-9][.]* | wc -l; du -s -b --apparent-size $localrawpath; else echo '-1 -1 -1'; fi` )
    archive=( `if [ -d $localrawpath3 ]; then ls $localrawpath3/${date2}_[0-9][0-9][0-9][.]* 2>/dev/null | wc -l; du -L -s -b --apparent-size $localrawpath3; else echo '-1 -1 -1'; fi` )
@@ -177,5 +189,5 @@
    wue=( `ssh operator@coma.astro.uni-wuerzburg.de "if [ -d $wuerawpath ]; then ls $wuerawpath/${date2}_[0-9][0-9][0-9][.]* | wc -l; du -s -b --apparent-size $wuerawpath; else echo '-1 -1 -1'; fi"` )
    #phido=( `ssh -i /home_nfs/isdc/fact_opr/.ssh/id_rsa.fact_opr.phido 129.217.160.201 "if [ -d $phidorawpath ]; then ls $phidorawpath/* | wc -l; du -s -b --apparent-size $phidorawpath; else echo '-1 -1 -1'; fi"` )
-   qla=( `ssh fact@161.72.93.131 "ls $qlapath/20*_C.root 2>/dev/null | wc -l"` )
+   qla=( `ssh fact@161.72.93.138 "ls $qlapath/20*_C.root 2>/dev/null | wc -l"` )
    query="SELECT Sum(if(fHasDrsFile=1,2,1)) FROM RunInfo WHERE fNight="$date2
    querystart="SELECT Sum(if(fHasDrsFile=1,2,1)) FROM "
@@ -225,21 +237,21 @@
    
    printprocesslog "disk: "
-   printprocesslog "  newdaq  "${newdaq[@]}
-   printprocesslog "  daq     "${daq[@]}
-   printprocesslog "  data    "${zip[@]}
-   printprocesslog "  dl00    "${dl00[@]}
-   printprocesslog "  wue     "${wue[@]}
-   printprocesslog "  arch    "${archive[@]}
-   printprocesslog "  fail    "${fails[@]}
+   printprocesslog "  newdaq      "${newdaq[@]}
+   printprocesslog "  newdata     "${daq[@]}
+   printprocesslog "  newdata zip "${zip[@]}
+   printprocesslog "  dl00        "${dl00[@]}
+   printprocesslog "  wue         "${wue[@]}
+   printprocesslog "  arch        "${archive[@]}
+   printprocesslog "  fail        "${fails[@]}
    #printprocesslog "  phido   "${phido[@]}
-   printprocesslog "  qla     "${qla[@]}
+   printprocesslog "  qla         "${qla[@]}
    printprocesslog "db: "
-   printprocesslog "  runinfo "$numruns
-   printprocesslog "  rsynced "$numrsynced
-   printprocesslog "  isdc    "$numisdc
-   printprocesslog "  isdc    "$numisdc2" (incl fails folder)"
-   printprocesslog "  wue     "$numwue
+   printprocesslog "  runinfo     "$numruns
+   printprocesslog "  rsynced     "$numrsynced
+   printprocesslog "  isdc        "$numisdc
+   printprocesslog "  isdc        "$numisdc2" (incl fails folder)"
+   printprocesslog "  wue         "$numwue
    #printprocesslog "  phido   "$numphido
-   printprocesslog "  data    "$numdatruns
+   printprocesslog "  data        "$numdatruns
    echo "" >> $logfile 2>&1
    echo "" >> $logfile 2>&1
@@ -248,21 +260,21 @@
    echo "" >> $logfile 2>&1
    echo "disk: " >> $logfile 2>&1
-   echo "  newdaq  "${newdaq[@]} >> $logfile 2>&1
-   echo "  daq     "${daq[@]} >> $logfile 2>&1
-   echo "  data    "${zip[@]} >> $logfile 2>&1
-   echo "  dl00    "${dl00[@]} >> $logfile 2>&1
-   echo "  wue     "${wue[@]} >> $logfile 2>&1
-   echo "  arch    "${archive[@]} >> $logfile 2>&1
-   echo "  fail    "${fails[@]} >> $logfile 2>&1
+   echo "  newdaq      "${newdaq[@]} >> $logfile 2>&1
+   echo "  newdata     "${daq[@]} >> $logfile 2>&1
+   echo "  newdata zip "${zip[@]} >> $logfile 2>&1
+   echo "  dl00        "${dl00[@]} >> $logfile 2>&1
+   echo "  wue         "${wue[@]} >> $logfile 2>&1
+   echo "  arch        "${archive[@]} >> $logfile 2>&1
+   echo "  fail        "${fails[@]} >> $logfile 2>&1
    #echo "  phido   "${phido[@]} >> $logfile 2>&1
-   echo "  qla     "${qla[@]} >> $logfile 2>&1
+   echo "  qla         "${qla[@]} >> $logfile 2>&1
    echo "db: " >> $logfile 2>&1
-   echo "  runinfo "$numruns >> $logfile 2>&1
-   echo "  rsynced "$numrsynced >> $logfile 2>&1
-   echo "  isdc    "$numisdc >> $logfile 2>&1
-   echo "  isdc    "$numisdc2" (incl fails folder)" >> $logfile 2>&1
-   echo "  wue     "$numwue >> $logfile 2>&1
+   echo "  runinfo     "$numruns >> $logfile 2>&1
+   echo "  rsynced     "$numrsynced >> $logfile 2>&1
+   echo "  isdc        "$numisdc >> $logfile 2>&1
+   echo "  isdc        "$numisdc2" (incl fails folder)" >> $logfile 2>&1
+   echo "  wue         "$numwue >> $logfile 2>&1
    #echo "  phido   "$numphido >> $logfile 2>&1
-   echo "  datruns "$numdatruns >> $logfile 2>&1
+   echo "  datruns     "$numdatruns >> $logfile 2>&1
    
    if ! [ $numdatruns -eq $qla ]
@@ -290,6 +302,6 @@
    if ! [ ${daq[0]} -eq -1 ]  && ! [ ${daq[0]} -eq ${newdaq[0]} ]
    then
-      printprocesslog "WARN number of files on daq (" ${daq[0]}") does not agree with number of files on newdaq (" ${newdaq[0]}") for "$date
-      echo "WARN number of files on daq (" ${daq[0]}") does not agree with number of files on newdaq (" ${newdaq[0]}") for "$date >> $logfile 2>&1
+      printprocesslog "WARN number of files on newdata (" ${daq[0]}") does not agree with number of files on newdaq (" ${newdaq[0]}") for "$date
+      echo "WARN number of files on newdata (" ${daq[0]}") does not agree with number of files on newdaq (" ${newdaq[0]}") for "$date >> $logfile 2>&1
       numpb=`echo " $numpb + 1 " | bc -l `
       result1=$result1"1"
@@ -382,15 +394,15 @@
       echo "SUMMARY for "$date
       echo "-----------------------"
-      echo "  number of files does not yet agree in all sites: "${newdaq[0]}" (newdaq) "${daq[0]}" (daq) "${zip[0]}" (data) "${dl00[0]}" (dl) "${wue[0]}" (wue) "${archive[0]}" (arch) "${fails[0]}" (fails) "${qla[@]}" (qla) "$numdatruns" (datruns) "
+      echo "  number of files does not yet agree in all sites: "${newdaq[0]}" (newdaq) "${daq[0]}" (newdata) "${zip[0]}" (newdata zip) "${dl00[0]}" (dl) "${wue[0]}" (wue) "${archive[0]}" (arch) "${fails[0]}" (fails) "${qla[@]}" (qla) "$numdatruns" (datruns) "
       echo "  "$date" is not yet transfered completely. Please check the logfile "$logfile
       # print to single logfile
       echo "SUMMARY for "$date >> $logfile 2>&1
       echo "-----------------------" >> $logfile 2>&1
-      echo "  number of files does not yet agree in all sites: "${newdaq[0]}" (newdaq) "${daq[0]}" (daq) "${zip[0]}" (data) "${dl00[0]}" (dl) "${wue[0]}" (wue) "${archive[0]}" (arch) "${fails[0]}" (fails) "${qla[@]}" (qla) "$numdatruns" (datruns) " >> $logfile 2>&1
+      echo "  number of files does not yet agree in all sites: "${newdaq[0]}" (newdaq) "${daq[0]}" (newdata) "${zip[0]}" (newdata zip) "${dl00[0]}" (dl) "${wue[0]}" (wue) "${archive[0]}" (arch) "${fails[0]}" (fails) "${qla[@]}" (qla) "$numdatruns" (datruns) " >> $logfile 2>&1
       echo "  "$date" is not yet transfered completely. Please check the logfile "$logfile >> $logfile 2>&1
       # print to global logfile
       echo "SUMMARY for "$date >> $logfile2 2>&1
       echo "-----------------------" >> $logfile2 2>&1
-      echo "  number of files does not yet agree in all sites: "${newdaq[0]}" (newdaq) "${daq[0]}" (daq) "${zip[0]}" (data) "${dl00[0]}" (dl) "${wue[0]}" (wue) "${archive[0]}" (arch) "${fails[0]}" (fails) "${qla[@]}" (qla) "$numdatruns" (datruns) " >> $logfile2 2>&1
+      echo "  number of files does not yet agree in all sites: "${newdaq[0]}" (newdaq) "${daq[0]}" (newdata) "${zip[0]}" (newdata zip) "${dl00[0]}" (dl) "${wue[0]}" (wue) "${archive[0]}" (arch) "${fails[0]}" (fails) "${qla[@]}" (qla) "$numdatruns" (datruns) " >> $logfile2 2>&1
       echo "  "$date" is not yet transfered completely. Please check the logfile "$logfile >> $logfile2 2>&1
       continue
@@ -401,6 +413,6 @@
    if ! [ ${newdaq[1]} -eq ${daq[1]} ]
    then
-      printprocesslog "INFO size of data doesn't agree on newdaq ("${newdaq[1]}") and daq ("${daq[1]}") for "$date
-      echo "WARN size of data doesn't agree on newdaq ("${newdaq[1]}") and daq ("${daq[1]}") for "$date >> $logfile 2>&1
+      printprocesslog "INFO size of data doesn't agree on newdaq ("${newdaq[1]}") and newdata ("${daq[1]}") for "$date
+      echo "WARN size of data doesn't agree on newdaq ("${newdaq[1]}") and newdata ("${daq[1]}") for "$date >> $logfile 2>&1
       numdiff=`echo " $numdiff + 1 " | bc -l `
       numpb=`echo " $numpb + 1 " | bc -l `
@@ -414,6 +426,6 @@
    if ! [ ${zip[1]} -eq ${dl00[1]} ] && [ $date2 -gt 20120307 ]
    then
-      printprocesslog "INFO size of data doesn't agree on data ("${zip[1]}") and dl00 ("${dl00[1]}") for "$date
-      echo "WARN size of data doesn't agree on data ("${zip[1]}") and dl00 ("${dl00[1]}") for "$date >> $logfile 2>&1
+      printprocesslog "INFO size of data doesn't agree on newdata-zip ("${zip[1]}") and dl00 ("${dl00[1]}") for "$date
+      echo "WARN size of data doesn't agree on newdata-zip ("${zip[1]}") and dl00 ("${dl00[1]}") for "$date >> $logfile 2>&1
       if ! [ ${dl00[1]} -eq -1 ]
       then 
@@ -432,6 +444,6 @@
    if ! [ ${zip[1]} -eq ${archive[1]} ]
    then
-      printprocesslog "INFO size of data doesn't agree on data ("${zip[1]}") and in archive ("${archive[1]}") for "$date
-      echo "WARN size of data doesn't agree on data ("${zip[1]}") and in archive ("${archive[1]}") for "$date >> $logfile 2>&1
+      printprocesslog "INFO size of data doesn't agree on newdata-zip ("${zip[1]}") and in archive ("${archive[1]}") for "$date
+      echo "WARN size of data doesn't agree on newdata-zip ("${zip[1]}") and in archive ("${archive[1]}") for "$date >> $logfile 2>&1
       if ! [ ${archive[1]} -eq -1 ]
       then 
@@ -450,6 +462,6 @@
    if ! [ ${zip[1]} -eq ${wue[1]} ]
    then
-      printprocesslog "INFO size of data doesn't agree on data ("${zip[1]}") and in Wue ("${wue[1]}") for "$date
-      echo "WARN size of data doesn't agree on data ("${zip[1]}") and in Wue ("${wue[1]}") for "$date >> $logfile 2>&1
+      printprocesslog "INFO size of data doesn't agree on newdata-zip ("${zip[1]}") and in Wue ("${wue[1]}") for "$date
+      echo "WARN size of data doesn't agree on newata-zip ("${zip[1]}") and in Wue ("${wue[1]}") for "$date >> $logfile 2>&1
       if ! [ ${wue[1]} -eq -1 ]
       then 
@@ -468,6 +480,6 @@
    #if ! [ ${zip[1]} -eq ${phido[1]} ]
    #then
-   #   printprocesslog "WARN size of data doesn't agree on data ("${zip[1]}") and on Phido ("${phido[1]}") for "$date
-   #   echo "WARN size of data doesn't agree on data ("${zip[1]}") and on Phido ("${phido[1]}") for "$date >> $logfile 2>&1
+   #   printprocesslog "WARN size of data doesn't agree on newdata-zip ("${zip[1]}") and on Phido ("${phido[1]}") for "$date
+   #   echo "WARN size of data doesn't agree on newdata-zip ("${zip[1]}") and on Phido ("${phido[1]}") for "$date >> $logfile 2>&1
    #   if ! [ ${phido[1]} -eq -1 ]
    #   then 
@@ -616,8 +628,8 @@
          
          # get file sizes for run
-         #sizenewdaq=( `ssh fact@161.72.93.131 "ls -l ${lprawpath}/${rawfile} 2>/dev/null | awk '{ print \\\$5 }'"` )
-         sizenewdaq=( `ssh fact@161.72.93.131 "ls -lH ${lprawpath}/${rawfile2} 2>/dev/null | awk '{ print \\\$5 }'"` )
-         sizedaq=( `ssh fact@161.72.93.131 "ls -l $lprawpath2/$rawfile2 2>/dev/null | awk '{ print \\\$5 }'"` )
-         sizezip=( `ssh fact@161.72.93.131 "ls -l $lpziprawpath/$rawfile2 2>/dev/null | awk '{ print \\\$5 }'"` )
+         #sizenewdaq=( `ssh fact@161.72.93.138 "ls -l ${lprawpath}/${rawfile} 2>/dev/null | awk '{ print \\\$5 }'"` )
+         sizenewdaq=( `ssh fact@161.72.93.138 "ls -lH ${lprawpath}/${rawfile2} 2>/dev/null | awk '{ print \\\$5 }'"` )
+         sizedaq=( `ssh fact@161.72.93.138 "ls -l $lprawpath2/$rawfile2 2>/dev/null | awk '{ print \\\$5 }'"` )
+         sizezip=( `ssh fact@161.72.93.138 "ls -l $lpziprawpath/$rawfile2 2>/dev/null | awk '{ print \\\$5 }'"` )
          if ! [ ${dl00[1]} -eq -1 ]
          then
@@ -639,5 +651,5 @@
          if [ "$sizenewdaq" = "" ] ||  [ "$sizedaq" = "" ] ||  [ "$sizezip" = "" ] ||  [ "$sizedl00" = "" ] ||  [ "$sizewue" = "" ] || ([ "$sizefails" = "" ] &&  [ "$sizearchive" = "" ])	
          then
-            printprocesslog "WARN one or more of the sizes empty: "$sizenewdaq"(newdaq) "$sizedaq"(daq) "$sizezip"(data) "$sizedl00"(dl) "$sizewue"(wue) "$sizefails"(fails) "$sizearchive"(arch) "
+            printprocesslog "WARN one or more of the sizes empty: "$sizenewdaq"(newdaq) "$sizedaq"(newdata) "$sizezip"(newdata zip) "$sizedl00"(dl) "$sizewue"(wue) "$sizefails"(fails) "$sizearchive"(arch) "
             continue
          fi
@@ -651,6 +663,6 @@
          if ! [ "$sizenewdaq" = "$sizedaq" ]
          then
-            printprocesslog "WARN "$rawfile2" newdaq("$sizenewdaq") daq("$sizedaq")"
-            echo "  "$rawfile2" newdaq("$sizenewdaq") daq("$sizedaq")" >> $logfile 2>&1
+            printprocesslog "WARN "$rawfile2" newdaq("$sizenewdaq") newdata("$sizedaq")"
+            echo "  "$rawfile2" newdaq("$sizenewdaq") newdata("$sizedaq")" >> $logfile 2>&1
             daqdiffcounter=`echo " $daqdiffcounter + 1 " | bc -l `
          else
@@ -660,6 +672,6 @@
          if ! [ "$sizezip" = "$sizedl00" ] && ! [ ${dl00[1]} -eq -1 ]
          then
-            printprocesslog "WARN "$rawfile2" data("$sizezip") dl00("$sizedl00")"
-            echo "  "$rawfile2" data("$sizezip") dl00("$sizedl00")" >> $logfile 2>&1
+            printprocesslog "WARN "$rawfile2" newdata-zip("$sizezip") dl00("$sizedl00")"
+            echo "  "$rawfile2" newdata-zip("$sizezip") dl00("$sizedl00")" >> $logfile 2>&1
             dl00diffcounter=`echo " $dl00diffcounter + 1 " | bc -l `
          else
@@ -671,6 +683,6 @@
          if [ ${archive[1]} -ne -1 -a "$sizezip" != "$sizearchive" -a "$sizezip" != "$sizefails" ] 
          then
-            printprocesslog "WARN "$rawfile2" data("$sizezip") archive("$sizearchive"/"$sizefails")"
-            echo "  "$rawfile2" data("$sizezip") archive("$sizearchive"/"$sizefails")" >> $logfile 2>&1
+            printprocesslog "WARN "$rawfile2" newdata-zip("$sizezip") archive("$sizearchive"/"$sizefails")"
+            echo "  "$rawfile2" newdata-zip("$sizezip") archive("$sizearchive"/"$sizefails")" >> $logfile 2>&1
             #echo " "$sizezip"-"$sizearchive"-"${archive[1]}"-"$sizezip"-"$sizefails"-"${fails[1]}
             archivediffcounter=`echo " $archivediffcounter + 1 " | bc -l `
@@ -681,6 +693,6 @@
          if ! [ "$sizezip" = "$sizewue" ] && ! [ ${wue[1]} -eq -1 ]
          then
-            printprocesslog "WARN "$rawfile2" data("$sizezip") wue("$sizewue")"
-            echo "  "$rawfile2" data("$sizezip") wue("$sizewue")" >> $logfile 2>&1
+            printprocesslog "WARN "$rawfile2" newdata-zip("$sizezip") wue("$sizewue")"
+            echo "  "$rawfile2" newdata-zip("$sizezip") wue("$sizewue")" >> $logfile 2>&1
             wuediffcounter=`echo " $wuediffcounter + 1 " | bc -l `
          else
@@ -690,6 +702,6 @@
          #if ! [ "$sizezip" = "$sizephido" ] && ! [ ${phido[1]} -eq -1 ]
          #then
-         #   printprocesslog "  "$rawfile2" data("$sizezip") phido("$sizephido")"
-         #   echo "  "$rawfile2" data("$sizezip") phido("$sizephido")" >> $logfile 2>&1
+         #   printprocesslog "  "$rawfile2" newdata-zip("$sizezip") phido("$sizephido")"
+         #   echo "  "$rawfile2" newdata-zip("$sizezip") phido("$sizephido")" >> $logfile 2>&1
          #   phidodiffcounter=`echo " $phidodiffcounter + 1 " | bc -l `
          #else
@@ -708,8 +720,8 @@
          rawfile2=$rawfile".*z"
          # get file sizes for run
-         #sizenewdaq=( `ssh fact@161.72.93.131 "ls -l ${lprawpath}/${rawfile} 2>/dev/null | awk '{ print \\\$5 }'"` )
-         sizenewdaq=( `ssh fact@161.72.93.131 "ls -lH ${lprawpath}/${rawfile} 2>/dev/null | awk '{ print \\\$5 }'"` )
-         sizedaq=( `ssh fact@161.72.93.131 "ls -l $lprawpath2/$rawfile 2>/dev/null | awk '{ print \\\$5 }'"` )
-         sizezip=( `ssh fact@161.72.93.131 "ls -l $lpziprawpath/$rawfile2 2>/dev/null | awk '{ print \\\$5 }'"` )
+         #sizenewdaq=( `ssh fact@161.72.93.138 "ls -l ${lprawpath}/${rawfile} 2>/dev/null | awk '{ print \\\$5 }'"` )
+         sizenewdaq=( `ssh fact@161.72.93.138 "ls -lH ${lprawpath}/${rawfile} 2>/dev/null | awk '{ print \\\$5 }'"` )
+         sizedaq=( `ssh fact@161.72.93.138 "ls -l $lprawpath2/$rawfile 2>/dev/null | awk '{ print \\\$5 }'"` )
+         sizezip=( `ssh fact@161.72.93.138 "ls -l $lpziprawpath/$rawfile2 2>/dev/null | awk '{ print \\\$5 }'"` )
          if ! [ ${dl00[1]} -eq -1 ]
          then
@@ -734,5 +746,5 @@
          if [ "$sizenewdaq" = "" ] ||  [ "$sizedaq" = "" ] ||  [ "$sizezip" = "" ] ||  [ "$sizedl00" = "" ] ||  [ "$sizewue" = "" ] || ([ "$sizefails" = "" ] &&  [ "$sizearchive" = "" ])
          then
-            printprocesslog "WARN one or more of the sizes empty: "$sizenewdaq"(newdaq) "$sizedaq"(daq) "$sizezip"(data) "$sizedl00"(dl) "$sizewue"(wue) "$sizefails"(fails) "$sizearchive"(arch) "
+            printprocesslog "WARN one or more of the sizes empty: "$sizenewdaq"(newdaq) "$sizedaq"(newdata) "$sizezip"(newdata zip) "$sizedl00"(dl) "$sizewue"(wue) "$sizefails"(fails) "$sizearchive"(arch) "
             continue
          fi
@@ -742,6 +754,6 @@
          if ! [ "$sizenewdaq" = "$sizedaq" ]
          then
-            printprocesslog "WARN "$rawfile" newdaq("$sizenewdaq") daq("$sizedaq")"
-            echo "  "$rawfile" newdaq("$sizenewdaq") daq("$sizedaq")" >> $logfile 2>&1
+            printprocesslog "WARN "$rawfile" newdaq("$sizenewdaq") newdata("$sizedaq")"
+            echo "  "$rawfile" newdaq("$sizenewdaq") newdata("$sizedaq")" >> $logfile 2>&1
             daqdiffcounter=`echo " $daqdiffcounter + 1 " | bc -l `
          else
@@ -751,6 +763,6 @@
          if ! [ "$sizezip" = "$sizedl00" ] && ! [ ${dl00[1]} -eq -1 ]
          then
-            printprocesslog "WARN "$rawfile2" data("$sizezip") dl00("$sizedl00")"
-            echo "  "$rawfile2" data("$sizezip") dl00("$sizedl00")" >> $logfile 2>&1
+            printprocesslog "WARN "$rawfile2" newdata-zip("$sizezip") dl00("$sizedl00")"
+            echo "  "$rawfile2" newdata-zip("$sizezip") dl00("$sizedl00")" >> $logfile 2>&1
             dl00diffcounter=`echo " $dl00diffcounter + 1 " | bc -l `
          else
@@ -760,6 +772,6 @@
          if [  "$sizezip" != "$sizearchive"  -a  ${archive[1]} -ne -1 -a "$sizearchive" != "" ] || [  "$sizezip" != "$sizefails" -a ${fails[1]} -ne -1 -a "$sizefails" != "" ]
          then
-            printprocesslog "WARN "$rawfile2" data("$sizezip") archive("$sizearchive"/"$sizefails")"
-            echo "  "$rawfile2" data("$sizezip") archive("$sizearchive"/"$sizefails")" >> $logfile 2>&1
+            printprocesslog "WARN "$rawfile2" newdata-zip("$sizezip") archive("$sizearchive"/"$sizefails")"
+            echo "  "$rawfile2" newdata-zip("$sizezip") archive("$sizearchive"/"$sizefails")" >> $logfile 2>&1
             archivediffcounter=`echo " $archivediffcounter + 1 " | bc -l `
          else
@@ -769,6 +781,6 @@
          if ! [ "$sizezip" = "$sizewue" ] && ! [ ${wue[1]} -eq -1 ]
          then
-            printprocesslog "WARN "$rawfile2" data("$sizezip") wue("$sizewue")"
-            echo "  "$rawfile2" data("$sizezip") wue("$sizewue")" >> $logfile 2>&1
+            printprocesslog "WARN "$rawfile2" newdata-zip("$sizezip") wue("$sizewue")"
+            echo "  "$rawfile2" newdata-zip("$sizezip") wue("$sizewue")" >> $logfile 2>&1
             wuediffcounter=`echo " $wuediffcounter + 1 " | bc -l `
          else
@@ -778,6 +790,6 @@
          #if ! [ "$sizezip" = "$sizephido" ] && ! [ ${phido[1]} -eq -1 ]
          #then
-         #   printprocesslog "WARN "$rawfile2" data("$sizezip") phido("$sizephido")"
-         #   echo "  "$rawfile2" data("$sizezip") phido("$sizephido")" >> $logfile 2>&1
+         #   printprocesslog "WARN "$rawfile2" newdata-zip("$sizezip") phido("$sizephido")"
+         #   echo "  "$rawfile2" newdata-zip("$sizezip") phido("$sizephido")" >> $logfile 2>&1
          #   phidodiffcounter=`echo " $phidodiffcounter + 1 " | bc -l `
          #else
@@ -839,10 +851,10 @@
       #   numpb=`echo " $numpb + 1 " | bc -l `
       #fi
-      printprocesslog "INFO "$daqokcounter" files are ok on daq (raw)."
+      printprocesslog "INFO "$daqokcounter" files are ok on newdata."
       printprocesslog "INFO "$dl00okcounter" files are ok on dl00."
       printprocesslog "INFO "$wueokcounter" files are ok in Wue."
       printprocesslog "INFO "$archiveokcounter" files are ok in the archive."
       #printprocesslog "INFO "$phidookcounter" files are ok on Phido."
-      echo "INFO "$daqokcounter" files are ok on daq (raw)." >> $logfile 2>&1
+      echo "INFO "$daqokcounter" files are ok on newdata." >> $logfile 2>&1
       echo "INFO "$dl00okcounter" files are ok on dl00." >> $logfile 2>&1
       echo "INFO "$wueokcounter" files are ok in Wue." >> $logfile 2>&1
@@ -851,9 +863,9 @@
       if [ $daqdiffcounter -gt 0 ]
       then 
-         printprocesslog "WARN "$daqdiffcounter" files have a different size on daq (raw)."
-         echo "WARN "$daqdiffcounter" files have a different size on daq (raw)." >> $logfile 2>&1
-      else
-         printprocesslog "INFO "$daqdiffcounter" files have a different size on daq (raw)."
-         echo "INFO "$daqdiffcounter" files have a different size on daq (raw)." >> $logfile 2>&1
+         printprocesslog "WARN "$daqdiffcounter" files have a different size on newdata."
+         echo "WARN "$daqdiffcounter" files have a different size on newdata." >> $logfile 2>&1
+      else
+         printprocesslog "INFO "$daqdiffcounter" files have a different size on newdata."
+         echo "INFO "$daqdiffcounter" files have a different size on newdata." >> $logfile 2>&1
       fi
       if [ $dl00diffcounter -gt 0 ]
@@ -957,7 +969,7 @@
    if [ $daqdiffcounter -gt 0 ]
    then 
-      echo "  WARN "$daqdiffcounter" files have a different size on daq (raw)."
-      echo "  WARN "$daqdiffcounter" files have a different size on daq (raw)." >> $logfile 2>&1
-      echo "  WARN "$daqdiffcounter" files have a different size on daq (raw)." >> $logfile2 2>&1
+      echo "  WARN "$daqdiffcounter" files have a different size on newdata."
+      echo "  WARN "$daqdiffcounter" files have a different size on newdata." >> $logfile 2>&1
+      echo "  WARN "$daqdiffcounter" files have a different size on newdata." >> $logfile2 2>&1
    fi
    if [ $dl00diffcounter -gt 0 ]