Index: trunk/Mars/mjobs/MJMerpp.cc
===================================================================
--- trunk/Mars/mjobs/MJMerpp.cc	(revision 18576)
+++ trunk/Mars/mjobs/MJMerpp.cc	(revision 18957)
@@ -389,9 +389,9 @@
         SetPathOut(name2);
 
-        const Int_t rc = Process();
-        if (rc==0)
+        const Int_t rc2 = Process();
+        if (rc2==0)
             continue;
 
-        return rc;
+        return rc2;
     }
     return 0;
Index: trunk/Mars/mjobs/MJSimulation.cc
===================================================================
--- trunk/Mars/mjobs/MJSimulation.cc	(revision 18576)
+++ trunk/Mars/mjobs/MJSimulation.cc	(revision 18957)
@@ -1108,9 +1108,9 @@
                 gPad->SetGridy();
                 gROOT->SetSelectedPad(0);
-                MHCamera *c = new MHCamera(static_cast<MGeomCam&>(*env1.GetCont()));
-                c->SetStats(kFALSE);
-                c->SetBit(MHCamera::kNoLegend);
-                c->SetBit(kCanDelete);
-                c->Draw();
+                MHCamera *hcam = new MHCamera(static_cast<MGeomCam&>(*env1.GetCont()));
+                hcam->SetStats(kFALSE);
+                hcam->SetBit(MHCamera::kNoLegend);
+                hcam->SetBit(kCanDelete);
+                hcam->Draw();
             }
 
@@ -1123,9 +1123,9 @@
                 gPad->SetGridy();
                 gROOT->SetSelectedPad(0);
-                MHCamera *c = new MHCamera(*cam);
-                c->SetStats(kFALSE);
-                c->SetBit(MHCamera::kNoLegend);
-                c->SetBit(kCanDelete);
-                c->Draw();
+                MHCamera *hcam = new MHCamera(*cam);
+                hcam->SetStats(kFALSE);
+                hcam->SetBit(MHCamera::kNoLegend);
+                hcam->SetBit(kCanDelete);
+                hcam->Draw();
             }
         }
@@ -1173,11 +1173,11 @@
         gPad->SetGridy();
         gROOT->SetSelectedPad(0);
-        MParSpline *all = (MParSpline*)splinepde.DrawClone();
+        MParSpline *sall = (MParSpline*)splinepde.DrawClone();
         //all->SetTitle("Combined acceptance");
-        all->SetBit(kCanDelete);
+        sall->SetBit(kCanDelete);
         if (splinemirror.GetSpline())
-            all->Multiply(*splinemirror.GetSpline());
+            sall->Multiply(*splinemirror.GetSpline());
         if (splinecones2.GetSpline())
-            all->Multiply(*splinecones2.GetSpline());
+            sall->Multiply(*splinecones2.GetSpline());
     }
 
Index: trunk/Mars/mjobs/MSequence.cc
===================================================================
--- trunk/Mars/mjobs/MSequence.cc	(revision 18576)
+++ trunk/Mars/mjobs/MSequence.cc	(revision 18957)
@@ -321,6 +321,6 @@
     while (!files.IsNull())
     {
-        const TString num = files(regexp);
-        if (num.IsNull())
+        const TString fnum = files(regexp);
+        if (fnum.IsNull())
         {
             *fLog << warn << "WARNING - File in run " << run << " is NaN (not a number): '" << files << "'" << endl;
@@ -328,27 +328,27 @@
         }
 
-        const Ssiz_t p1 = num.First(':');
-        if (p1>=0)
+        const Ssiz_t q1 = fnum.First(':');
+        if (q1>=0)
         {
-            const Int_t n1 = atoi(num.Data());
-            const Int_t n2 = atoi(num.Data()+p1+1);
-
-            if (n2<n1)
+            const Int_t m1 = atoi(fnum.Data());
+            const Int_t m2 = atoi(fnum.Data()+q1+1);
+
+            if (m2<m1)
             {
-                *fLog << warn << "WARNING - Invalid range in '" << num << "'... ignored." << endl;
+                *fLog << warn << "WARNING - Invalid range in '" << fnum << "'... ignored." << endl;
                 return;
             }
 
             // FIXME: n2==0 || n2<n1
-            for (int i=n1; i<=n2; i++)
+            for (int i=m1; i<=m2; i++)
                 AddEntry(run, i, data, sub);
         }
         else
         {
-            const Int_t file = atoi(num.Data());
+            const Int_t file = atoi(fnum.Data());
             AddEntry(run, file, data, sub);
         }
 
-        files.Remove(0, files.First(num)+num.Length());
+        files.Remove(0, files.First(fnum)+fnum.Length());
     }
 }